/*
  help.cpp
  Copyright (C) 2008 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of qgmap.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#include "qgmap.h"
#include "help.h"

Help::Help(QWidget *parent, const char *name, WFlags f) :
	QLabel(parent, name, f)
{
	QLabel::hide();
	setFrameStyle(QFrame::Box | QFrame::Plain);
#ifdef QWS
	setFont(QFont("lcfont", 16));
#else
	setFont(QFont("gothic", 8));
#endif
	setMargin(2);
	setText(QString::fromUtf8(
		"Help\n"
		" カーソル : 上下左右スクロール (Shift+カーソルで大幅移動)\n"
		"   I,O    : ズームイン, アウト\n"
		"   0-9    : 保存位置読み出し\n"
		"Shift+0-9 : 位置保存 (0 は初期位置)\n"
		"    J     : 緯度・経度指定ジャンプ\n"
		"    M     : マーカ表示ON/OFF\n"
		"            (ツールチップ表示中に 0-9 キーで個別マーカON/OFF)\n"
		" Shift+M  : 画面外マーカ表示方法切り替え\n"
		"    .     : 中央に十時マーカを表示\n"
		"Fn+C/Ctl+C: 現在位置をクリップボードへコピー\n"
		"Fn+V/Ctl+V: クリップボードの位置へジャンプ\n"
		"    D     : フリーハンド範囲指定モード\n"
		"            (地図ダウンロード補佐機能)\n"
		"  H or ?  : ヘルプ表示"
						   ));
	adjustSize();
}

void Help::show()
{
	int x, y;
	QWidget *parent = parentWidget();

	x = (parent->width()-width())/2;
	y = (parent->height()-height())/2;
	setGeometry(x, y,
				width(), height());
	QLabel::show();
}

void Help::keyPressEvent(QKeyEvent * e UNUSED)
{
	hide();
}

void Help::mousePressEvent(QMouseEvent *e UNUSED)
{
	hide();
}
